import { GamePageResp, SubjectPageDataResp, SaveGameFormDataT, SaveGameResp, HomeworkDataResp, SaveHomeworkGameResp, StartNewRoundResp } from './res-types';
export declare type RequestData = {
    action: string;
    method?: 'get' | 'post';
    params?: {};
    dataParams?: {};
};
declare type P = {
    isIsolated: boolean;
    apiHost: string;
    homeworkPath: string;
    moveToRoot: () => void;
    openNotificationWithIcon: (props: any) => void;
};
export declare class ApiConnector {
    private static instance;
    private readonly moveToRoot;
    private readonly openNotificationWithIcon;
    private readonly apiHost;
    private readonly homeworkPath;
    private readonly isIsolated;
    static getInstance(p: P): ApiConnector;
    getSubjectPageData(subjectID?: number): Promise<SubjectPageDataResp>;
    getHomeworkPageData<T>(isolatedResp: HomeworkDataResp<T>): Promise<HomeworkDataResp<T>>;
    getGamePageData(isHomework: boolean, game: string, isolatedResp: GamePageResp): Promise<GamePageResp>;
    saveGame(p: Omit<SaveGameFormDataT, 'hometaskId'>): Promise<SaveGameResp>;
    saveHomeworkGame(p: SaveGameFormDataT): Promise<SaveHomeworkGameResp>;
    startNewRound<T>(p: {
        subjectID: number;
        userID: number;
    }): Promise<StartNewRoundResp<T>>;
    private readonly ACTIONS;
    private constructor();
    private request;
}
export {};
