"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ApiConnector = void 0;
var axios_1 = require("axios");
var config_1 = require("./config");
var output_actions_1 = require("./output-actions");
var utils_1 = require("./utils");
var isolated_resps_1 = require("./isolated-resps");
var tokens_generators_1 = require("./tokens-generators");
var ApiConnector = /** @class */ (function () {
    function ApiConnector(_a) {
        var isIsolated = _a.isIsolated, apiHost = _a.apiHost, homeworkPath = _a.homeworkPath, moveToRoot = _a.moveToRoot, openNotificationWithIcon = _a.openNotificationWithIcon;
        //---------------
        this.ACTIONS = {
            GET_HOMEWORK_PAGE_DATA: 'student_interface_homework_page',
            GET_SUBJECT_PAGE_DATA: 'student_interface_subject_page',
            SAVE_GAME: 'student_interface_save_game_action',
            START_NEW_ROUND: 'student_interface_start_new_round_action',
            SAVE_HOMEWORK_GAME: 'student_interface_save_homework_progress',
            GET_GAME_PAGE_DATA: 'student_interface_game_page'
        };
        this.moveToRoot = moveToRoot;
        this.openNotificationWithIcon = openNotificationWithIcon;
        this.apiHost = apiHost;
        this.isIsolated = isIsolated;
        this.homeworkPath = homeworkPath;
    }
    ApiConnector.getInstance = function (p) {
        if (!ApiConnector.instance) {
            ApiConnector.instance = new ApiConnector(p);
        }
        return ApiConnector.instance;
    };
    ApiConnector.prototype.getSubjectPageData = function (subjectID) {
        var data = {
            action: this.ACTIONS.GET_SUBJECT_PAGE_DATA,
            method: 'get',
            params: {
                subjectID: subjectID
            }
        };
        return this.request(data, false, isolated_resps_1.subjectPageDataIsolatedResp);
    };
    ApiConnector.prototype.getHomeworkPageData = function (isolatedResp) {
        var data = {
            action: this.ACTIONS.GET_HOMEWORK_PAGE_DATA,
            method: 'get',
        };
        return this.request(data, false, isolatedResp);
    };
    ApiConnector.prototype.getGamePageData = function (isHomework, game, isolatedResp) {
        var data = {
            action: this.ACTIONS.GET_GAME_PAGE_DATA,
            method: 'get',
            params: {
                isHomework: isHomework ? 1 : 0,
                game: game
            }
        };
        return this.request(data, false, isolatedResp);
    };
    ApiConnector.prototype.saveGame = function (p) {
        var token = tokens_generators_1.generateTokenForGameSaving(p);
        var data = {
            action: this.ACTIONS.SAVE_GAME,
            method: 'get',
            params: __assign({ token: token }, p)
        };
        return this.request(data, false, {});
    };
    ApiConnector.prototype.saveHomeworkGame = function (p) {
        var token = tokens_generators_1.generateTokenForHomeworkGameSaving(p);
        var data = {
            action: this.ACTIONS.SAVE_HOMEWORK_GAME,
            method: 'get',
            params: __assign({ token: token }, p)
        };
        return this.request(data, false, {});
    };
    ApiConnector.prototype.startNewRound = function (p) {
        var data = {
            action: this.ACTIONS.START_NEW_ROUND,
            method: 'get',
            params: __assign({}, p)
        };
        return this.request(data, false, {});
    };
    ApiConnector.prototype.request = function (data, noReloadIfStatusFalse, isolatedResp) {
        if (noReloadIfStatusFalse === void 0) { noReloadIfStatusFalse = false; }
        return __awaiter(this, void 0, void 0, function () {
            var _a, method, action, _b, params, initDataParams, url, dataParams, formData, requestBody, serverResponse, resData, status, outputData, message, outputAction, resolver;
            var _this = this;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        if (!this.isIsolated) return [3 /*break*/, 2];
                        return [4 /*yield*/, isolatedResp];
                    case 1: return [2 /*return*/, _c.sent()];
                    case 2:
                        _a = data.method, method = _a === void 0 ? 'get' : _a, action = data.action, _b = data.params, params = _b === void 0 ? {} : _b, initDataParams = data.dataParams;
                        url = this.apiHost + action;
                        dataParams = method === 'post' ? (initDataParams ? initDataParams : params) : {};
                        formData = new FormData();
                        utils_1.buildFormData(formData, dataParams);
                        requestBody = {
                            method: method,
                            url: url,
                            params: __assign({ app_code: config_1.apiConfig.APP_CODE }, params),
                            withCredentials: true,
                            data: formData,
                            headers: {
                                'Content-Type': 'application/x-www-form-urlencoded'
                            }
                        };
                        return [4 /*yield*/, axios_1.default(requestBody)];
                    case 3:
                        serverResponse = _c.sent();
                        return [4 /*yield*/, serverResponse.data];
                    case 4:
                        resData = _c.sent();
                        status = resData.status, outputData = resData.data;
                        if (status) {
                            return [2 /*return*/, outputData];
                        }
                        message = outputData.message, outputAction = outputData.action;
                        if (message) {
                            this.openNotificationWithIcon({ type: 'warning', msg: message });
                            if (outputAction) {
                                resolver = output_actions_1.outputActions[outputAction];
                                if (typeof resolver === 'function') {
                                    resolver(this.homeworkPath);
                                }
                            }
                            else {
                                if (!noReloadIfStatusFalse) {
                                    setTimeout(function () {
                                        _this.moveToRoot();
                                    }, 2000);
                                }
                            }
                        }
                        else {
                            this.moveToRoot();
                        }
                        return [2 /*return*/, null];
                }
            });
        });
    };
    return ApiConnector;
}());
exports.ApiConnector = ApiConnector;
//# sourceMappingURL=api-connector.js.map