"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.buildFormData = void 0;
var buildFormData = function (formData, data, parentKey) {
    if (data && typeof data === 'object' && !(data instanceof Date) && !(data instanceof File)) {
        Object.keys(data).forEach(function (key) {
            exports.buildFormData(formData, data[key], parentKey ? parentKey + "[" + key + "]" : key);
        });
    }
    else {
        var value = data == null ? '' : data;
        if (typeof data === 'string' && data.includes('data:image/png;base64,')) {
            value = b64toBlob(data, 'image/png', 512);
            formData.append(parentKey, value, 'yourImage.png');
        }
        else {
            formData.append(parentKey, value);
        }
    }
};
exports.buildFormData = buildFormData;
var b64toBlob = function (b64Data, contentType, sliceSize) {
    contentType = contentType || '';
    sliceSize = sliceSize || 512;
    var str = b64Data.replace('data:image/png;base64,', '');
    var byteCharacters = atob(str);
    var byteArrays = [];
    for (var offset = 0; offset < byteCharacters.length; offset += sliceSize) {
        var slice = byteCharacters.slice(offset, offset + sliceSize);
        var byteNumbers = new Array(slice.length);
        for (var i = 0; i < slice.length; i++) {
            byteNumbers[i] = slice.charCodeAt(i);
        }
        var byteArray = new Uint8Array(byteNumbers);
        byteArrays.push(byteArray);
    }
    return new Blob(byteArrays, { type: contentType });
};
//# sourceMappingURL=from-data-builder.js.map